LeetCode-633. 平方数之和

1、题目描述

给定一个非负整数 c ,你要判断是否存在两个整数 a 和 b,使得 a2 + b2 = c 。

示例 1:

复制代码
输入:c = 5
输出:true
解释:1 * 1 + 2 * 2 = 5

示例 2:

复制代码
输入:c = 3
输出:false

提示:

  • 0 <= c <= 231 - 1

2、代码:

cpp 复制代码
class Solution {
public:
    bool judgeSquareSum(int c) {
        // 定义两个指针 a 和 b
        // a 从 0 开始,b 从 sqrt(c) 开始
        long a = 0; // 使用 long 防止溢出
        long b = static_cast<long>(sqrt(c)); // b 初始化为 c 的平方根
        
        // 双指针法:a 从左向右移动,b 从右向左移动
        while (a <= b) {
            // 计算当前 a^2 + b^2 的值
            auto sum = a * a + b * b;
            
            if (sum > c) {
                // 如果 sum 大于 c,说明 b 的值太大了,需要减小 b
                --b;
            } else if (sum < c) {
                // 如果 sum 小于 c,说明 a 的值太小了,需要增大 a
                ++a;
            } else {
                // 如果 sum 等于 c,找到了符合条件的 a 和 b,返回 true
                return true;
            }
        }
        
        // 如果循环结束仍未找到符合条件的 a 和 b,返回 false
        return false;
    }
};

3、解题思路

  1. 数学性质:

    • 如果存在两个整数 a 和 b 满足 a^2 + b^2 = c,那么 a 和 b 的平方值一定在 [0, c] 范围内。
    • 因此,我们可以通过枚举一个变量(如 a),并计算另一个变量(如 b)是否满足条件。
  2. 双指针法:

    • 使用两个指针 a 和 b,分别从 0 和 sqrt(c) 开始移动。
    • 计算当前的平方和 sum = a^2 + b^2:
      • 如果 sum == c,说明找到了符合条件的 a 和 b,返回 true。
      • 如果 sum < c,说明需要增大 a(即让 a++)。
      • 如果 sum > c,说明需要减小 b(即让 b--)。
    • 当 a > b 时,结束循环,返回 false。
  3. 时间复杂度:

    • 由于 a 和 b 分别从两端向中间移动,最多需要遍历 O(sqrt(c)) 次,因此时间复杂度为 O(sqrt(c))。
相关推荐
信奥卷王8 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵8 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
徐小黑ACG10 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
码完就睡10 小时前
数据结构——红黑树
数据结构
码爸10 小时前
数据结构详细介绍
数据结构
Navigator_Z10 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛11 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记11 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序11 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm